/* 

                          Firewall Builder

                 Copyright (C) 2000 NetCitadel, LLC

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: NewHostDruid.hh,v 1.4 2003/05/02 06:10:55 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _NEWHOST_DRUID_HH
#define _NEWHOST_DRUID_HH

#include <Druid.hh>

#include "fwbuilder/FWObject.hh"
#include "fwbuilder/IPAddress.hh"
#include "fwbuilder/Firewall.hh"
#include "fwbuilder/Host.hh"

#include <vector>

class NewHostDruidP10Dialog;
class NewHostDruidP20Dialog;

class libfwbuilder::Firewall;

class main_window;

class NewHostDruid : public Druid {

    NewHostDruidP10Dialog  *p10;
    NewHostDruidP20Dialog  *p20;

    main_window            *main_w;

    public:

    NewHostDruid(main_window *mw,const string &t, const string& l);

    virtual void     on_prepare();
    virtual gboolean on_next();
    virtual gboolean on_back();
    virtual gboolean on_cancel();
    virtual void     on_finish();
};

#endif
