/* 

                          Firewall Builder

                 Copyright (C) 2000 NetCitadel, LLC

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: popupMenu.hh,v 1.2 2002/08/29 00:34:51 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _POPUPMENU_HH
#  define _POPUPMENU_HH

#include <map>

#include <gtk--/menu.h>
#include <gtk--/menuitem.h>
#include <gtk--/list.h>

// Generic popup menu

class popupMenu : public Gtk::Menu
{   

    map<int,Gtk::MenuItem*> menu_items;

    void on_item_activate();
    void on_menu_cancel();
    void on_menu_deactivate();

    int   choice;

    public:

    popupMenu(const char** menu_items );
    ~popupMenu();

    void set_sensitive(int n,bool flag);
    Gtk::MenuItem* get_item(int n);

/*
 * this signal is sent when user makes selection in popup menu
 */
    SigC::Signal1<void,int>menu_select;
};


#endif
