/* 

                          Firewall Builder

                 Copyright (C) 2002 NetCitadel, LLC

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: TargetDialog_pix.hh,v 1.1 2002/11/26 05:24:37 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _TARGETDIALOG_PIX_HH
#  include "TargetDialog_pix_glade.hh"
#  define _TARGETDIALOG_PIX_HH
#include "glademm_support.hh"



#include "fwbuilder/FWObject.hh"

#include "DialogPlugin.hh"

namespace libfwbuilder
{
    class FWOptions;
};


class TargetDialog_pix : public TargetDialog_pix_glade
{   
        
    friend class TargetDialog_pix_glade;
    void on_changed();
    void on_pix_advanced_fw_clicked();
    void on_edit_prolog_clicked();
    void on_edit_epilog_clicked();

    libfwbuilder::FWOptions        *fwoptions;
    std::vector<class DialogOption> options;

    void getVersions(std::vector<std::string> &versions);

    public:

    TargetDialog_pix(libfwbuilder::FWObject *o);

    virtual void readDefaults();
    virtual void wrk2dlg();
    virtual bool dlg2wrk();
};

extern "C" DialogPlugin* create_dialog_pix(libfwbuilder::FWObject *o);


#endif
